diff --git a/src/common/resources/lang/en_US/biomes.lang b/src/common/resources/lang/en_US/biomes.lang
index 41dd17986..4c56f2bb5 100644
--- a/src/common/resources/lang/en_US/biomes.lang
+++ b/src/common/resources/lang/en_US/biomes.lang
@@ -2,6 +2,7 @@ biome.rainforest=Rainforest
 biome.swampland=Swamp
 biome.seasonal_forest=Seasonal Forest
 biome.forest=Forest
+biome.forest.dry=Dry Forest
 biome.grasslands=Grasslands
 biome.outback=Outback
 biome.shrubland=Shrubland
@@ -19,4 +20,5 @@ biome.retro=Retro
 biome.hell=Hell
 biome.swampland.muddy=Muddy Swamp
 biome.outback.grassy=Grassy Outback
-biome.caatinga=Caatinga
\ No newline at end of file
+biome.caatinga=Caatinga
+biome.caatinga.plains=Caatinga Plains
\ No newline at end of file
diff --git a/src/common/resources/lang/en_US/gui.lang b/src/common/resources/lang/en_US/gui.lang
index 8d5cad6a6..175eb1050 100644
--- a/src/common/resources/lang/en_US/gui.lang
+++ b/src/common/resources/lang/en_US/gui.lang
@@ -336,4 +336,5 @@ model.category.block.spawner.button.id=Mob: %s
 model.category.particle.name=Particle
 model.category.particle.info=Particle: %s
 model.category.particle.radius.slider=Radius: %s
-model.category.particle.note.slider=Note: %s
\ No newline at end of file
+model.category.particle.note.slider=Note: %s
+model.category.particle.block.side=Side: %s
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index bde651192..023043528 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -384,11 +384,17 @@ public class Minecraft
             setRenderer(new Renderer(this));
         }
 
+        texturePackList = new TexturePackList(this, mcDataDir);
+        renderEngine = new RenderEngine(this, texturePackList, gameSettings);
+        
+        // Show load screen as early as possible
+        // Do not put stuff that takes a while to load before this,
+        // otherwise the loading time will happen while the window is black
+        loadScreen();
+        
         // Initialize overworld biome map
         BiomeProviderOverworld.init();
 
-        texturePackList = new TexturePackList(this, mcDataDir);
-        renderEngine = new RenderEngine(this, texturePackList, gameSettings);
         ColorizerWater.updateColorData(renderEngine.getTextureImageData("/misc/watercolor.png"));
         ColorizerGrass.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor.png"));
         ColorizerFoliage.updateColorData(renderEngine.getTextureImageData("/misc/foliagecolor.png"));
@@ -407,7 +413,9 @@ public class Minecraft
             }
             return String.format(s, gameSettings.keyGuidebook.getKeyName());
         });
-        loadScreen();
+
+        loadScreen();	// Update loading screen so it doesn't say no response
+        
         StatList.init();
 
         System.out.println("Initizalizing input");
@@ -437,8 +445,13 @@ public class Minecraft
         glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
         OpenGLHelper.checkError("startup");
         sndManager.loadSoundSettings(gameSettings);
+        
+        loadScreen();	// Update loading screen so it doesn't say no response
+        
         renderEngine.refreshTextures(new ArrayList<>());
 
+        loadScreen();	// Update loading screen so it doesn't say no response
+        
         System.out.println("Initializing Renderer...");
         
         TextureRegistry.blockAtlas.bindTexture();
@@ -475,6 +488,8 @@ public class Minecraft
         System.out.printf("%d item groups.%n",itemGroups);
         System.out.printf("%d recipes in %d groups in %d namespaces.%n",recipes,groups,namespaces);
 
+        loadScreen();	// Update loading screen so it doesn't say no response
+        
         // Enable Discord Rich Presence
         if (gameSettings.discordRichPresence.value)
         {
@@ -1200,6 +1215,9 @@ public class Minecraft
                 chunkproviderloadorgenerate.setCurrentChunkOver(playerChunkX, playerChunkZ);
             }
         }
+        if(theWorld != null) {
+        	theWorld.updateAllOnLightChange = !LightmapHelper.isLightmapEnabled();
+        }
         if(!isGamePaused && theWorld != null)
         {
             playerController.tick();
diff --git a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index 7eaa8b089..fb3fe72ac 100644
--- a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -39,6 +39,7 @@ public class RichPresenceHandlerThread extends Thread
         biomeNamesMap.put(Biomes.OVERWORLD_SWAMPLAND, "the swamplands");
         biomeNamesMap.put(Biomes.OVERWORLD_SEASONAL_FOREST, "a seasonal forest");
         biomeNamesMap.put(Biomes.OVERWORLD_FOREST, "a forest");
+        biomeNamesMap.put(Biomes.OVERWORLD_FOREST_DRY, "a dry forest");
         biomeNamesMap.put(Biomes.OVERWORLD_GRASSLANDS, "the grasslands");
         biomeNamesMap.put(Biomes.OVERWORLD_OUTBACK, "the outback");
         biomeNamesMap.put(Biomes.OVERWORLD_SHRUBLAND, "a shrubland");
@@ -57,6 +58,7 @@ public class RichPresenceHandlerThread extends Thread
         biomeNamesMap.put(Biomes.OVERWORLD_SWAMPLAND_MUDDY, "the swamplands");
         biomeNamesMap.put(Biomes.OVERWORLD_OUTBACK_GRASSY, "the outback");
         biomeNamesMap.put(Biomes.OVERWORLD_CAATINGA, "the caatinga");
+        biomeNamesMap.put(Biomes.OVERWORLD_CAATINGA_PLAINS, "the caatinga");
     }
     private static Map<Weather, String> weatherNamesMap = new HashMap<>();
     static
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityItemFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityItemFX.java
index 5c0cbe9b3..576d4a826 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityItemFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityItemFX.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.entity.fx;
 
+import net.minecraft.client.render.LightmapHelper;
+
 // Referenced classes of package net.minecraft.src:
 //            EntityFX, Item, Block, TessellatorStandard,
 //            World
@@ -39,8 +41,13 @@ public class EntityItemFX extends EntityFX
         float f11 = (float)((xo + (x - xo) * (double) partialTick) - lerpPosX);
         float f12 = (float)((yo + (y - yo) * (double) partialTick) - lerpPosY);
         float f13 = (float)((zo + (z - zo) * (double) partialTick) - lerpPosZ);
-        float f14 = getBrightness(partialTick);
-        t.setColorOpaque_F(f14 * particleRed, f14 * particleGreen, f14 * particleBlue);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        }else {
+        	brightness = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(brightness * particleRed, brightness * particleGreen, brightness * particleBlue);
         t.addVertexWithUV(f11 - rotationX * f10 - rotationYZ * f10, f12 - rotationXZ * f10, f13 - rotationZ * f10 - rotationXY * f10, f6, f9);
         t.addVertexWithUV((f11 - rotationX * f10) + rotationYZ * f10, f12 + rotationXZ * f10, (f13 - rotationZ * f10) + rotationXY * f10, f6, f8);
         t.addVertexWithUV(f11 + rotationX * f10 + rotationYZ * f10, f12 + rotationXZ * f10, f13 + rotationZ * f10 + rotationXY * f10, f7, f8);
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityLavaFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityLavaFX.java
index f21e8403c..3c99ebee0 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityLavaFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityLavaFX.java
@@ -52,7 +52,7 @@ public class EntityLavaFX extends EntityFX
         float f = (float)particleAge / (float)particleMaxAge;
         if(random.nextFloat() > f)
         {
-            world.spawnParticle("smoke", x, y, z, xd, yd, zd);
+            world.spawnParticle("smoke", x, y, z, xd, yd, zd, 0);
         }
         yd -= 0.03D;
         move(xd, yd, zd);
diff --git a/src/main/java/net/minecraft/client/entity/fx/EntityLeafFX.java b/src/main/java/net/minecraft/client/entity/fx/EntityLeafFX.java
index df98cfd2a..5ae6ea979 100644
--- a/src/main/java/net/minecraft/client/entity/fx/EntityLeafFX.java
+++ b/src/main/java/net/minecraft/client/entity/fx/EntityLeafFX.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.entity.fx;
 
+import net.minecraft.client.render.LightmapHelper;
+
 // Referenced classes of package net.minecraft.src:
 //            EntityFX, Block, TessellatorStandard, World
 
@@ -87,8 +89,13 @@ public class EntityLeafFX extends EntityFX
         float f11 = (float)((xo + (x - xo) * (double) partialTick) - lerpPosX);
         float f12 = (float)((yo + (y - yo) * (double) partialTick) - lerpPosY);
         float f13 = (float)((zo + (z - zo) * (double) partialTick) - lerpPosZ);
-        float f14 = getBrightness(partialTick);
-        t.setColorOpaque_F(f14 * particleRed, f14 * particleGreen, f14 * particleBlue);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        }else {
+        	brightness = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(brightness * particleRed, brightness * particleGreen, brightness * particleBlue);
         t.addVertexWithUV(f11 - rotationX * f10 - rotationYZ * f10, f12 - rotationXZ * f10, f13 - rotationZ * f10 - rotationXY * f10, f6, f9);
         t.addVertexWithUV((f11 - rotationX * f10) + rotationYZ * f10, f12 + rotationXZ * f10, (f13 - rotationZ * f10) + rotationXY * f10, f6, f8);
         t.addVertexWithUV(f11 + rotationX * f10 + rotationYZ * f10, f12 + rotationXZ * f10, f13 + rotationZ * f10 + rotationXY * f10, f7, f8);
diff --git a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
index 2c8c5ced7..eb73d7b8b 100644
--- a/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/fx/ParticleDispatcher.java
@@ -5,13 +5,15 @@ import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.animal.EntityFireflyCluster;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.BlockParticleHelper;
+import net.minecraft.core.util.helper.MathHelper;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
     private static final ParticleDispatcher instance = new ParticleDispatcher();
+    private static final ParticleLambda blank = (world, x, y, z, motionX, motionY, motionZ, data) -> null;
     public static ParticleDispatcher getInstance()
     {
         return instance;
@@ -21,45 +23,44 @@ public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
     }
     @Override
     protected ParticleLambda getDefault() {
-        return null;
+        return blank;
     }
     private ParticleDispatcher(){
         Minecraft mc = Minecraft.getMinecraft(this);
-        addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ) -> new EntityBubbleFX(world, x, y, z, motionX, motionY, motionZ, true));
-        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ) -> new EntityNoteFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ) -> new EntityPortalFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ) -> new EntityExplodeFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.ORANGE));
-        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.BLUE));
-        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.SOUL));
-        addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ) -> new EntityLavaFX(world, x, y, z));
-        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFootStepFX(mc.renderEngine, world, x, y, z));
-        addDispatch("splash", EntitySplashFX::new);
-        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX, 2.5f));
-        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ) -> new EntityReddustFX(world, x, y, z, (float) motionX, (float) motionY, (float) motionX));
-        addDispatch("item", (world, x, y, z, motionX, motionY, motionZ) -> new EntityItemFX(world, x, y, z, Item.itemsList[(int) (motionX + 0.001d)]));
-        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ) -> new EntityDiggingFX(world, x, y, z,0,0,0, Block.blocksList[(int) (motionX + 0.001d)], Side.BOTTOM.getId(),(int) (motionY + 0.001d)));
-        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ) -> new EntitySnowShovelFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ) -> new EntityHeartFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ) -> {
+        addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityBubbleFX(world, x, y, z, motionX, motionY, motionZ, true));
+        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityNoteFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityPortalFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityExplodeFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.ORANGE));
+        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.BLUE));
+        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFlameFX(world, x, y, z, motionX, motionY, motionX, EntityFlameFX.Type.SOUL));
+        addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityLavaFX(world, x, y, z));
+        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFootStepFX(mc.renderEngine, world, x, y, z));
+        addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new EntitySplashFX(world1, d, d1, d2, d3, d4, d5));
+        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySmokeFX(world, x, y, z, motionX, motionY, motionX, 2.5f));
+        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityReddustFX(world, x, y, z, (float) motionX, (float) motionY, (float) motionX));
+        addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityItemFX(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
+        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityDiggingFX(world, x, y, z,motionX,motionY,motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).setParticleColor((int) x, (int) y, (int) z));
+        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntitySnowShovelFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityHeartFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ, data) -> {
             if (mc.gameSettings.slimeParticles.value){
                 return new EntitySlimeChunkFX(world, x, y, z, Item.slimeball);
             }
             return null;
         });
-        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.GREEN.getId()));
-        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.BLUE.getId()));
-        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.ORANGE.getId()));
-        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.RED.getId()));
-        addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ) -> new EntityArrowGoldenFX(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("fallingleaf", (world, x, y, z, motionX, motionY, motionZ) -> {
+        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.GREEN.getId()));
+        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.BLUE.getId()));
+        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.ORANGE.getId()));
+        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityFireflyFX(world, x, y, z, motionX, motionY, motionX, EntityFireflyCluster.FireflyColor.RED.getId()));
+        addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ, data) -> new EntityArrowGoldenFX(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("fallingleaf", (world, x, y, z, motionX, motionY, motionZ, data) -> {
             int id = world.getBlockId((int)x, (int)y, (int)z);
             if (id != 0){
                 return new EntityLeafFX(world, x, y, z, motionX, motionY, motionX).func_4041_a((int)x, (int)y, (int)z);
             }
             return null;
         });
-        addDispatch("boatbreak", (world, x, y, z, motionX, motionY, motionZ) -> new EntityDiggingFX(world, x, y, z, motionX, motionY, motionX, Block.planksOak, Side.BOTTOM.getId(), 0));
     }
 }
diff --git a/src/main/java/net/minecraft/client/entity/fx/ParticleLambda.java b/src/main/java/net/minecraft/client/entity/fx/ParticleLambda.java
index 394377380..c7307f955 100644
--- a/src/main/java/net/minecraft/client/entity/fx/ParticleLambda.java
+++ b/src/main/java/net/minecraft/client/entity/fx/ParticleLambda.java
@@ -4,5 +4,5 @@ import net.minecraft.core.world.World;
 
 @FunctionalInterface
 public interface ParticleLambda {
-    EntityFX newParticle(World world, double x, double y, double z, double motionX, double motionY, double motionZ);
+    EntityFX newParticle(World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data);
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
index 6a884f8e8..4b8bad0f2 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
@@ -26,8 +26,8 @@ public class MobSpawnerEntry extends BlockEntry{
         double xPos = (double) spawner.x + spawner.worldObj.rand.nextFloat();
         double yPos = (double) spawner.y + spawner.worldObj.rand.nextFloat();
         double zPos = (double) spawner.z + spawner.worldObj.rand.nextFloat();
-        spawner.worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
-        spawner.worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
+        spawner.worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
+        spawner.worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
         for(spawner.yaw += 1000F / ((float)spawner.delay + 200F); spawner.yaw > 360D;)
         {
             spawner.yaw -= 360D;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
index a0d1e6e57..6fde34902 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
@@ -22,7 +22,7 @@ public class EntityFireflyEntry extends EntityEntry<EntityFireflyCluster>{
         double dz = (random.nextFloat() * 2F - 1F) * (fireflyCluster.bbWidth);
 
         if (random.nextInt(Math.max(1, 10 - fireflyCluster.getFireflyCount())) == 0) {
-            fireflyCluster.world.spawnParticle(fireflyCluster.getColor().getParticleName(), fireflyCluster.x + dx, fireflyCluster.y + dy, fireflyCluster.z + dz, fireflyCluster.xd, fireflyCluster.yd, fireflyCluster.zd, 99999D);
+            fireflyCluster.world.spawnParticle(fireflyCluster.getColor().getParticleName(), fireflyCluster.x + dx, fireflyCluster.y + dy, fireflyCluster.z + dz, fireflyCluster.xd, fireflyCluster.yd, fireflyCluster.zd, 0, 99999D);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
index 10fcb96ff..c9c160cc9 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
@@ -5,19 +5,22 @@ import net.minecraft.client.entity.fx.EntityDiggingFX;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import java.util.Arrays;
 import java.util.List;
 
 public class BlockFXEntry extends GenericFXEntry{
     protected int blockId;
     protected int meta;
+    private Side side = Side.BOTTOM;
 
     public BlockFXEntry() {
         super("block");
@@ -26,7 +29,7 @@ public class BlockFXEntry extends GenericFXEntry{
     @Override
     public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
         List<GuiButton> buttonList = super.getEntryButtons(mc, parentScreen);
-        GuiTextCycle<Integer> blockIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, buttonList.get(buttonList.size()-1).yPosition + 21, 120, 20, blockId) {
+        GuiTextCycle<Integer> blockIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, buttonList.get(buttonList.size()-1).getY() + 21, 120, 20, blockId) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return GuiModelViewer.cycleBlockId(current, offset);
@@ -51,7 +54,7 @@ public class BlockFXEntry extends GenericFXEntry{
         blockIdCycle.setOnValueChanged(() -> blockId = blockIdCycle.getCurrentElement());
         buttonList.add(blockIdCycle);
 
-        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, blockIdCycle.yPosition + 21, 120, 20, 0) {
+        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, blockIdCycle.getY() + 21, 120, 20, 0) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return (current + offset) & 0x3FFF;
@@ -76,12 +79,21 @@ public class BlockFXEntry extends GenericFXEntry{
         metaCycle.setOnValueChanged(() -> meta = metaCycle.getCurrentElement());
         buttonList.add(metaCycle);
 
+        GuiListSelectorButton<Side> sideButton = new GuiListSelectorButton<Side>(-1, -120, metaCycle.getY() + 21, 120, 20, I18n.getInstance().translateKey("model.category.particle.block.side"), Arrays.asList(Side.sides), side) {
+            @Override
+            public String getNameFromElement(Side element) {
+                return element.name();
+            }
+        };
+        sideButton.setOnValueChanged(() -> this.side = sideButton.getCurrentElement());
+        buttonList.add(sideButton);
+
         return buttonList;
     }
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityDiggingFX(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), Side.BOTTOM.getId(), meta));
+        mc.effectRenderer.addEffect(new EntityDiggingFX(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), side.getId(), meta));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
index 0dde12094..3d0c226e3 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
@@ -6,6 +6,7 @@ import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
+import org.lwjgl.input.Keyboard;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -17,6 +18,7 @@ public class GenericFXEntry extends ParticleEntry{
     protected double motionX;
     protected double motionY;
     protected double motionZ;
+    protected int data;
 
     public GenericFXEntry(String particleID){
         this(particleID, null);
@@ -57,6 +59,19 @@ public class GenericFXEntry extends ParticleEntry{
                 motionZ = Double.parseDouble(mzField.getText());
             } catch (Exception ignored){}
         });
+        GuiListenerTextField dataField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, mzField.yPosition + 21, 120, 20, String.valueOf(data), "Data");
+        dataField.setPrefaceText("Data: ");
+        dataField.setKeyListener(key -> {
+            try {
+                data = Integer.parseInt(dataField.getText());
+            } catch (Exception ignored){}
+        });
+        dataField.setActionListener(() -> {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL)){
+                dataField.setText(String.valueOf(0));
+                data = 0;
+            }
+        });
         buttons.add(mxField);
         buttons.add(myField);
         buttons.add(mzField);
@@ -65,7 +80,7 @@ public class GenericFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        world.spawnParticle(particleID, x, y, z, motionX, motionY, motionZ);
+        world.spawnParticle(particleID, x, y, z, motionX, motionY, motionZ, data);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
index abda90ff7..563d0dd58 100644
--- a/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/NetClientHandler.java
@@ -1,19 +1,6 @@
 package net.minecraft.client.net.handler;
 
-import java.io.BufferedReader;
-import java.io.IOException;
-import java.io.InputStreamReader;
-import java.net.InetAddress;
-import java.net.Socket;
-import java.net.URL;
-import java.net.UnknownHostException;
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Random;
-
 import com.b100.utils.StringUtils;
-
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.fx.EntityPickupFX;
 import net.minecraft.client.entity.player.EntityClientPlayerMP;
@@ -145,6 +132,18 @@ import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.weather.Weather;
 
+import java.io.BufferedReader;
+import java.io.IOException;
+import java.io.InputStreamReader;
+import java.net.InetAddress;
+import java.net.Socket;
+import java.net.URL;
+import java.net.UnknownHostException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Random;
+
 public class NetClientHandler extends NetHandler
 {
     private boolean disconnected;
@@ -1202,6 +1201,7 @@ public class NetClientHandler extends NetHandler
                         packet63SpawnParticleEffect.motionX + rand.nextGaussian() * packet63SpawnParticleEffect.randMotionX,
                         packet63SpawnParticleEffect.motionY + rand.nextGaussian() * packet63SpawnParticleEffect.randMotionY,
                         packet63SpawnParticleEffect.motionZ + rand.nextGaussian() * packet63SpawnParticleEffect.randMotionZ,
+                        packet63SpawnParticleEffect.data,
                         packet63SpawnParticleEffect.maxDistance);
             }
         } else {
@@ -1212,6 +1212,7 @@ public class NetClientHandler extends NetHandler
                     packet63SpawnParticleEffect.motionX,
                     packet63SpawnParticleEffect.motionY,
                     packet63SpawnParticleEffect.motionZ,
+                    packet63SpawnParticleEffect.data,
                     packet63SpawnParticleEffect.maxDistance);
         }
 
